//+------------------------------------------------------------------+
//|                                            MandarineXL v.0.1.mq4 |
//|                 orginal by hellkas  -  code by Alex.Piech.FinGeR |
//|                                        http://www.forex-tsd.com  |
//|                                                                  |
//| 13.10.2005  v.0.1 by Alex.Piech.FinGeR                           |
//+------------------------------------------------------------------+




#property copyright "hellkas"
#property link      "http://www.forex-tsd.com"
#define   MAGIC     200501013

extern string _Parameters_Trade = "-Parameters_Trade-";
extern double Lots           = 0.1;    
extern int    StopLoss       = 50;     
extern int    TakeProfit     = 200;     
extern bool   ProfitTrailing = True;   
extern int    TrailingStop   = 20;   
extern int    TrailingStep   = 3;      
extern int    Slippage       = 3;      
extern bool   UseHourTrade   = False;   
extern int    HourBegTrade   = 4;      
extern int    HourEndTrade   = 19;  
extern string _Parameters_Indicator = "-Parameters_Indicator-";
extern int    tPrLong        = 20;    
extern int    tPrShort       = 5;     
extern string _Parameters_Expert = "-Parameters_Expert-";
extern bool   UseOneAccount = False;    
extern int    NumberAccount = 71597;   
extern string Name_Expert   = "MandarineXL";
extern bool   UseSound      = True;         
extern string NameFileSound = "expert.wav"; 
extern color  clOpenBuy     = LightBlue;    
extern color  clOpenSell    = LightCoral;  
extern color  clModifyBuy   = Aqua;         
extern color  clModifySell  = Tomato;       
extern color  clCloseBuy    = Blue;         
extern color  clCloseSell   = Red;          

int prevBar; 

void deinit() 
{
  Comment("");
}


void start() {
  if (UseOneAccount && AccountNumber()!=NumberAccount) {
    Comment("UseOneAccount Number"+AccountNumber()+" FAILED!");
    return;
  } else Comment("");

  if (UseHourTrade && (Hour()<HourBegTrade || Hour()>=HourEndTrade)) {
    Comment("NO Trade Time!");
    return;
  } else Comment("");

  CheckForOpen();
  TrailingPositions();
}



void CheckForOpen() {
  double ldStop=0, ldTake=0;
  
  int Periods = 5;
 
  double a=0.8;
  double e1=iMA(NULL,0,Periods,0,MODE_EMA,PRICE_CLOSE,0); 
  double e2=iMA(NULL,0,Periods,0,MODE_EMA,e1,0); 
  double e3=iMA(NULL,0,Periods,0,MODE_EMA,e2,0); 
  double e4=iMA(NULL,0,Periods,0,MODE_EMA,e3,0); 
  double e5=iMA(NULL,0,Periods,0,MODE_EMA,e4,0); 
  double e6=iMA(NULL,0,Periods,0,MODE_EMA,e5,0); 
  
  double c1=-a*a*a;
  double c2=3*a*a+3*a*a*a;
  double c3=-6*a*a-3*a-3*a*a*a;
  double c4=1+3*a+a*a*a+3*a*a;
 
  double T3MA=c1*e6+c2*e5+c3*e4+c4*e3;
  
  double MALong  = iMA(NULL,0,tPrLong,0,MODE_EMA,PRICE_OPEN,0);     
  double MAShort = iMA(NULL,0,tPrShort,0,MODE_EMA,PRICE_CLOSE,0);   
  
  double MALong1  = iMA(NULL,0,tPrLong,0,MODE_EMA,PRICE_OPEN,1);    
  double MAShort1 = iMA(NULL,0,tPrShort,0,MODE_EMA,PRICE_CLOSE,1);
  
  if (!ExistPosition() && prevBar!=Bars) {
    
    if (MALong<MAShort && MALong1>MAShort1 && MAShort>T3MA) {
      
      if (StopLoss!=0) ldStop=Ask-StopLoss*Point;
      if (TakeProfit!=0) ldTake=Ask+TakeProfit*Point;
      SetOrder(OP_BUY, Ask, ldStop, ldTake);
      prevBar=Bars;
    }
    if (MALong>MAShort && MALong1<MAShort1 && MAShort<T3MA) {
      if (StopLoss!=0) ldStop=Bid+StopLoss*Point;
      if (TakeProfit!=0) ldTake=Bid-TakeProfit*Point;
      SetOrder(OP_SELL, Bid, ldStop, ldTake);
      prevBar=Bars;
    }
  }
}



bool ExistPosition() {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) Exist=True;
    }
  }
  return(Exist);
}


void SetOrder(int op, double pp, double ldStop, double ldTake) {
  color  clOpen;
  string lsComm=GetCommentForOrder();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpen);
  if (UseSound) PlaySound(NameFileSound);
}


string GetCommentForOrder() {
  return(Name_Expert);
}


void TrailingPositions() {

  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      //if (OrderMagicNumber()>MAGIC && OrderMagicNumber()<=MAGIC+5) {
        if (OrderSymbol()==Symbol()) {
          if (OrderType()==OP_BUY) {
            if (!ProfitTrailing || (Bid-OrderOpenPrice())>TrailingStop*Point) {
             
              if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*Point) {
                  ModifyStopLoss(Bid-TrailingStop*Point, clModifyBuy);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            if (!ProfitTrailing || OrderOpenPrice()-Ask>TrailingStop*Point) {
              if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss()==0) {
                ModifyStopLoss(Ask+TrailingStop*Point, clModifySell);
              }
            }
          }
        }
      }
    }
  }
//}


void ModifyStopLoss(double ldStop, color clModify) {

  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();

  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
 
  if (fm && UseSound) PlaySound(NameFileSound);
}


// regards  
// Alex.Piech.FinGeR  
// big thanks KimIV 



